package Objects;

import java.awt.Graphics;
import java.awt.Image;

import javax.imageio.ImageIO;

import Game.InputHandler;

public class COM extends GameplayObjects{
	//Statusvernderung des COMs
	public enum ComAction {UP, DOWN, GET, DEPLOY};
	private ComAction action;
	
	private int animSpeed = 25, animFrame = 1;
	private static long lastTime = System.currentTimeMillis();
	private long time = System.currentTimeMillis();
	private Image img2, img3;
	
	public COM()
	{
		try
		{
			this.img = ImageIO.read(this.getClass().getClassLoader().getResourceAsStream("com_static.png"));
			this.img2 = ImageIO.read(this.getClass().getClassLoader().getResourceAsStream("com_static2.png"));
			this.img3 = ImageIO.read(this.getClass().getClassLoader().getResourceAsStream("com_static3.png"));
		}
		catch(Exception e)
		{
			System.out.println("COM Grafik nicht gefunden!");
			System.exit(0);
		}
		this.posX = 448;
		this.posY = 615-img.getHeight(null);
		this.hotX = this.posX;
		this.hotY = this.posY + this.img.getHeight(null)/2;
		this.speed = 7;
		action = ComAction.DOWN;
	}
	@Override
	public void update(InputHandler input) {
		//Actions
		switch(action)
		{
		case UP:
			move(0, -speed);
			animate();
			break;
			
		case DOWN:
			move(0, +speed);
			animate();
			break;
			
		case GET:
			
			break;
			
		case DEPLOY:
			
			break;
		}
	}

	@Override
	public void render(Graphics g) {
		switch(action)
		{
		case UP:
			if(animFrame == 1)
			{
				g.drawImage(this.img,this.posX,this.posY, null);
			}
			else if(animFrame == 2)
			{
				g.drawImage(this.img2,this.posX,this.posY, null);
			}
			else if(animFrame == 3)
			{
				g.drawImage(this.img3,this.posX,this.posY, null);
			}
			break;
			
		case DOWN:
			if(animFrame == 1)
			{
				g.drawImage(this.img,this.posX,this.posY, null);
			}
			else if(animFrame == 2)
			{
				g.drawImage(this.img2,this.posX,this.posY, null);
			}
			else if(animFrame == 3)
			{
				g.drawImage(this.img3,this.posX,this.posY, null);
			}
			break;
			
		case GET:
			g.drawImage(this.img3,this.posX,this.posY, null);
			break;
			
		case DEPLOY:
			g.drawImage(this.img3,this.posX,this.posY, null);
			break;
		}
		
	}

	@Override
	public void move(int addX, int addY) {
		this.oldPosX = posX;
		this.oldPosY = posY;
		
		this.posX = this.posX + addX;
		this.posY = this.posY + addY;
		
		this.hotX = this.posX;
		this.hotY = this.posY + this.img.getHeight(null)/2;
	}
	void animate()
	{
		//Animation
		time = System.currentTimeMillis();
        
        if (time - lastTime > 1000/animSpeed) 
        { 
			animFrame++;
			lastTime = System.currentTimeMillis();
		}
		if(animFrame > 3)
		{
			animFrame = 1;
		}
	}
	public int getPosX()
	{
		return this.posX;
	}
	public int getPosY()
	{
		return this.posY;
	}
	public int getHotSpotY()
	{
		return hotY;
	}
	public int getHotSpotX() {
		
		return hotX;
	}
	public void setAction(ComAction newAction)
	{
		action = newAction;
	}
	public ComAction getAction()
	{
		return action;
	}
}
