package Objects;

import java.awt.Graphics;
import java.awt.Image;
import java.awt.event.KeyEvent;

import javax.imageio.ImageIO;

import Game.InputHandler;

public class Player extends GameplayObjects{

	private Image img2, img3;
	private boolean cooldown = false;
	private int animSpeed = 25, animFrame = 1, cooldownSec = 20;
	private static long lastTime = System.currentTimeMillis();
	private long time = System.currentTimeMillis();
	
	public Player()
	{
		
		try 
		{
			this.img = ImageIO.read(this.getClass().getClassLoader().getResourceAsStream("player_static.png"));
			this.img2 = ImageIO.read(this.getClass().getClassLoader().getResourceAsStream("player_static2.png"));
			this.img3 = ImageIO.read(this.getClass().getClassLoader().getResourceAsStream("player_static3.png"));
		} 
		catch (Exception e) {
			System.out.println("Spieler Grafik nicht gefunden!");
			System.exit(0);
		}
		this.posX = 64;
		this.posY = 615-img.getHeight(null);
		this.speed = 7;
		this.hotX = this.posX + this.img.getWidth(null);
		this.hotY = this.posY + this.img.getHeight(null)/2;
	}
	@Override
	public void update(InputHandler input) {

		//Steuerung
				if(input.isKeyDown(KeyEvent.VK_UP) && this.posY > 0)
				{
					move(0, -speed);
					animate();
				}
				else if(input.isKeyDown(KeyEvent.VK_DOWN) && this.posY < 620-img.getHeight(null))
				{
					move(0, +speed);
					animate();
				}
				

	}

	@Override
	public void render(Graphics g) {
		// TODO Auto-generated method stub
		if(animFrame == 1)
		{
			g.drawImage(this.img,this.posX,this.posY, null);
		}
		else if(animFrame == 2)
		{
			g.drawImage(this.img2,this.posX,this.posY, null);
		}
		else if(animFrame == 3)
		{
			g.drawImage(this.img3,this.posX,this.posY, null);
		}
		
	}
	@Override
	public void move(int addX, int addY) {
		// TODO Auto-generated method stub
		this.oldPosX = posX;
		this.oldPosY = posY;
		
		this.posX = this.posX + addX;
		this.posY = this.posY + addY;
		
		this.hotX = this.posX + this.img.getWidth(null);
		this.hotY = this.posY + this.img.getHeight(null)/2;
	}

	void animate()
	{
		//Animation
		
		time = System.currentTimeMillis();
        
        if (time - lastTime > 1000/animSpeed) 
        { 
			animFrame++;
			lastTime = System.currentTimeMillis();
		}
		if(animFrame > 3)
		{
			animFrame = 1;
		}
	}
	public int getPosX()
	{
		return this.posX;
	}
	public int getPosY()
	{
		return this.posY;
	}
	public int getHotSpotY()
	{
		return hotY;
	}
	public int getHotSpotX() {
		
		return hotX;
	}
}
