package Scenery;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.event.KeyEvent;

import javax.imageio.ImageIO;

import Game.InputHandler;
import Game.BallsDeep;
import Game.BallsDeep.GameState;
import Objects.BackGround;
import Objects.MenuBall;

public class Menu extends BlackBoard{

	private Image header, robot, robot2, start, options, exit, start_active, options_active, exit_active, menuBack1, menuBack2;
	private BackGround back1, back2;
	private int menuO = 1;
	private boolean keyStuck = true;
	private long safeCoolDown = System.currentTimeMillis();
	private MenuBall[] ballsTop = new MenuBall[5],ballsBot = new MenuBall[25];
	private Image[] ballImages = new Image[5];
	
	public Menu()
	{
		try
		{
			this.header = ImageIO.read(this.getClass().getClassLoader().getResourceAsStream("menu_header.png"));
			this.robot = ImageIO.read(this.getClass().getClassLoader().getResourceAsStream("robot.png"));
			this.start = ImageIO.read(this.getClass().getClassLoader().getResourceAsStream("start_inactive.png"));
			this.options = ImageIO.read(this.getClass().getClassLoader().getResourceAsStream("options_inactive.png"));
			this.exit = ImageIO.read(this.getClass().getClassLoader().getResourceAsStream("beenden_inactive.png"));
			this.start_active = ImageIO.read(this.getClass().getClassLoader().getResourceAsStream("start_active.png"));
			this.options_active = ImageIO.read(this.getClass().getClassLoader().getResourceAsStream("options_active.png"));
			this.exit_active = ImageIO.read(this.getClass().getClassLoader().getResourceAsStream("beenden_active.png"));
			this.menuBack1 = ImageIO.read(this.getClass().getClassLoader().getResourceAsStream("background1.png"));
			this.menuBack2 = ImageIO.read(this.getClass().getClassLoader().getResourceAsStream("background2.png"));
			this.robot2 = ImageIO.read(this.getClass().getClassLoader().getResourceAsStream("robot2.png"));
			//Ball Bilder Laden:
			for(int i = 0; i < ballImages.length; i++)
			{
				ballImages[i] = ImageIO.read(this.getClass().getClassLoader().getResourceAsStream("ball_"+Integer.toString(i)+".png"));
			}
		}
		catch(Exception e)
		{
			System.out.println("Grafik im Menu fehlerhaft!");
			e.printStackTrace();
			System.exit(0);
		}
		//Objekte
		for(int i = 0; i < ballsTop.length; i++)
		{
			ballsTop[i] = new MenuBall(ballImages);
		}
		for(int i = 0; i < ballsBot.length; i++)
		{
			ballsBot[i] = new MenuBall(ballImages);
		}
		back1 = new BackGround(menuBack1, 0,0,1);
		back2 = new BackGround(menuBack1, 640,0,1);
		
	}
	@Override
	public void update(InputHandler input) {
		//Background updaten
		back1.update(input);
		back2.update(input);
		//Balls Updaten
			for(int i = 0; i < ballsTop.length; i++)
			{
				ballsTop[i].update(input);
			}
			for(int i = 0; i < ballsBot.length; i++)
			{
				ballsBot[i].update(input);
			}
		
		if(System.currentTimeMillis()-safeCoolDown > 500)
		{
		if(input.isKeyDown(KeyEvent.VK_UP) && !keyStuck)
		{
			menuO -= 1;
			keyStuck = true;
		}
		if(input.isKeyDown(KeyEvent.VK_DOWN) && !keyStuck)
		{
			menuO += 1;
			keyStuck = true;
		}
		else if(!(input.isKeyDown(KeyEvent.VK_UP)) && !(input.isKeyDown(KeyEvent.VK_DOWN)))
		{
			keyStuck = false;
		}
		if(menuO < 1)
		{
			menuO = 3;
			
		}
		if(menuO > 3)
		{
			menuO = 1;
			
		}
		
		//Beenden
		if(input.isKeyDown(KeyEvent.VK_ENTER) && menuO == 3)
		{
			BallsDeep.endGame();
		}
		//Starten
		if(input.isKeyDown(KeyEvent.VK_ENTER) && menuO == 1)
		{
			BallsDeep.changeState(GameState.LEVEL);
		}
		//Optionen
		if(input.isKeyDown(KeyEvent.VK_ENTER) && menuO == 2)
		{
			BallsDeep.changeState(GameState.OPTIONS);
		}
	
		}
		
	}

	@Override
	public void render(Graphics g) {
		
		
		//Background
		back1.render(g);
		back2.render(g);
		
		//Balls rendern
				for(int i = 0; i < ballsBot.length; i++)
				{
					ballsBot[i].render(g);
				}
		g.drawImage(robot2, 270,270, null);
		g.drawImage(robot, 640-robot.getWidth(null),640-robot.getHeight(null), null);
		g.drawImage(header, 0,0,null);
		
		
		//Buttons
				if(menuO == 1)
				{
					g.drawImage(start_active, 60, 365,null);
				}
				else
				{
					g.drawImage(start, 60, 365,null);
				}
				if(menuO == 2)
				{
					g.drawImage(options_active, 60, 425,null);
				}
				else
				{
					g.drawImage(options, 60, 425,null);
				}
				if(menuO == 3)
				{
					g.drawImage(exit_active, 70, 480,null);
				}
				else
				{
					g.drawImage(exit, 70, 480,null);
				}
			//Vordergrund
				for(int i = 0; i < ballsTop.length; i++)
				{
					ballsTop[i].render(g);
				}	
				g.setColor(Color.BLACK);
				g.drawString("(c) Felix Bukatz | Mn. 550105 | MI2 2014", 15, 603);
	}

	@Override
	void changeGameState() {
		// TODO Auto-generated method stub
		
	}

}
