package Scenery;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.event.KeyEvent;

import javax.imageio.ImageIO;

import Game.BallsDeep;
import Game.InputHandler;
import Game.BallsDeep.GameState;
import Objects.BackGround;
import Objects.MenuBall;

public class Options extends BlackBoard{

	
	private Image menuBack1, diffBack, robot2, dimm;
	private BackGround back1, back2;
	private MenuBall[] ballsTop = new MenuBall[5],ballsBot = new MenuBall[5];
	private long safeCoolDown = System.currentTimeMillis();
	private Image[] ballImages = new Image[5];
	
	public Options()
	{
		try
		{
			this.menuBack1 = ImageIO.read(this.getClass().getClassLoader().getResourceAsStream("background1.png"));
			this.diffBack = ImageIO.read(this.getClass().getClassLoader().getResourceAsStream("time_back.png"));
			this.robot2 = ImageIO.read(this.getClass().getClassLoader().getResourceAsStream("robot2.png"));
			this.dimm = ImageIO.read(this.getClass().getClassLoader().getResourceAsStream("dimm.png"));
			//Ball Bilder Laden:
			for(int i = 0; i < ballImages.length; i++)
			{
				ballImages[i] = ImageIO.read(this.getClass().getClassLoader().getResourceAsStream("ball_"+Integer.toString(i)+".png"));
			}
		}
		catch(Exception e)
		{
			System.out.println("Grafik im Optionsmen fehlerhaft!");
			e.printStackTrace();
			System.exit(0);
		}
		
		//Objekte
		for(int i = 0; i < ballsTop.length; i++)
		{
			ballsTop[i] = new MenuBall(ballImages);
		}
		for(int i = 0; i < ballsBot.length; i++)
		{
			ballsBot[i] = new MenuBall(ballImages);
		}
		back1 = new BackGround(menuBack1, 0,0,1);
		back2 = new BackGround(menuBack1, 640,0,1);
		
	}
	
	@Override
	public void update(InputHandler input) {
		//Background updaten
		back1.update(input);
		back2.update(input);
		//Balls Updaten
		for(int i = 0; i < ballsTop.length; i++)
		{
			ballsTop[i].update(input);
		}
		for(int i = 0; i < ballsBot.length; i++)
		{
			ballsBot[i].update(input);
		}
		if(System.currentTimeMillis()-safeCoolDown > 200)
		{
			//Schwierigkeit ndern
			if(input.isKeyDown(KeyEvent.VK_UP))
			{
				BallsDeep.setDifficulty(+1);
				safeCoolDown = System.currentTimeMillis();
			}
			if(input.isKeyDown(KeyEvent.VK_DOWN))
			{
				BallsDeep.setDifficulty(-1);
				safeCoolDown = System.currentTimeMillis();
			}
		}
		
		//Frame beenden durch drcken von Escape
		if(input.isKeyDown(KeyEvent.VK_ESCAPE))
		{
			BallsDeep.changeState(GameState.MENU);
		}
	}

	@Override
	public void render(Graphics g) {
		//Background
		back1.render(g);
		back2.render(g);
			
		//Balls rendern
		for(int i = 0; i < ballsBot.length; i++)
		{
			ballsBot[i].render(g);
		}	
		for(int i = 0; i < ballsTop.length; i++)
		{
			ballsTop[i].render(g);
		}
		g.drawImage(dimm, 0,0, null);	
		g.drawImage(robot2, 0,420, null);
		g.setColor(Color.BLACK);
		g.drawString("(c) Felix Bukatz | Mn. 550105 | MI2 2014", 15, 603);
		
		g.drawImage(diffBack, 280,300,null);
		
		g.setColor(Color.WHITE);
		g.setFont(new Font("Impact", Font.PLAIN, 36));
		g.drawString("Stelle die Schwierigkeit ein!",90, 280);
		g.drawString(Integer.toString(BallsDeep.getDifficulty()),295, 345);
		g.drawString("Zurck mit Escape!",170, 420);
		
		
	}

	@Override
	void changeGameState() {
		// TODO Auto-generated method stub
		
	}
	

}
